Package: org.codehaus.groovy.classgen.asm

## [Java] Class BinaryFloatExpressionHelper

- org.codehaus.groovy.classgen.asm.BinaryFloatExpressionHelper

-     public class BinaryFloatExpressionHelper
      extends BinaryExpressionWriter

  Binary expression helper specialized for `float` operations.

- - Inherited fields
    Fields inherited from class | Fields
    --- | ---
    `class BinaryExpressionWriter` | `stdCompareCodes`

  - ### Constructor Summary

    Constructors
    Constructor and description
    `BinaryFloatExpressionHelper(WriterController controller)` Creates a `float`-specialized binary expression helper.

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `protected void` | `doubleTwoOperands(org.objectweb.asm.MethodVisitor mv)` * Duplicates the two operands already on the operand stack. * * Parameters: `mv` - the current method visitor
    `` | `protected int` | `getBitwiseOperationBytecode(int type)` * Returns the bitwise opcode for the supplied token. * * Parameters: `type` - the normalized token index * Returns: the ASM opcode
    `` | `protected int` | `getCompareCode()` * Returns: the ASM compare opcode used by this primitive type
    `` | `protected ClassNode` | `getDevisionOpResultType()` * Returns: the result type for division operations
    `` | `protected ClassNode` | `getNormalOpResultType()` * Returns: the result type for normal arithmetic operations
    `` | `protected int` | `getShiftOperationBytecode(int type)` * Returns the shift opcode for the supplied token. * * Parameters: `type` - the normalized token index * Returns: the ASM opcode
    `` | `protected int` | `getStandardOperationBytecode(int type)` * Returns the arithmetic opcode for the supplied token. * * Parameters: `type` - the normalized token index * Returns: the ASM opcode
    `` | `protected void` | `removeTwoOperands(org.objectweb.asm.MethodVisitor mv)` * Removes the two operands already on the operand stack. * * Parameters: `mv` - the current method visitor
    `` | `protected boolean` | `writeBitwiseOp(int type, boolean simulate)` * writes some the bitwise operations. type is one of BITWISE_OR, * BITWISE_AND, BITWISE_XOR * Parameters: `type` - the token type * Returns: true if a successful bitwise operation write
    `` | `protected void` | `writeMinusMinus(org.objectweb.asm.MethodVisitor mv)` * Emits a prefix/postfix decrement. * * Parameters: `mv` - the current method visitor
    `` | `protected void` | `writePlusPlus(org.objectweb.asm.MethodVisitor mv)` * Emits a prefix/postfix increment. * * Parameters: `mv` - the current method visitor
    `` | `protected boolean` | `writeShiftOp(int type, boolean simulate)` * Write shifting operations. * Type is one of LEFT_SHIFT, RIGHT_SHIFT, or RIGHT_SHIFT_UNSIGNED * * Parameters: `type` - the token type * Returns: true on a successful shift operation write

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class BinaryExpressionWriter` | `arrayGet, arraySet, doubleTwoOperands, getArrayGetCaller, getArrayGetResultType, getArraySetCaller, getBitwiseOperationBytecode, getCompareCode, getController, getDevisionOpResultType, getNormalOpResultType, getShiftOperationBytecode, getStandardOperationBytecode, removeTwoOperands, setArraySetAndGet, supportsDivision, write, writeBitwiseOp, writeDivision, writeMinusMinus, writePlusPlus, writePostOrPrefixMethod, writeShiftOp, writeSpaceship, writeStdCompare, writeStdOperators`

- - ### Constructor Detail

    - #### public BinaryFloatExpressionHelper(WriterController controller)

      Creates a `float`-specialized binary expression helper.

      Parameters:
        `controller` - the active writer controller

  - ### Method Detail

    - #### protected void doubleTwoOperands(org.objectweb.asm.MethodVisitor mv)

      * Duplicates the two operands already on the operand stack. * *

      Parameters:
        `mv` - the current method visitor

    - #### protected int getBitwiseOperationBytecode(int type)

      * Returns the bitwise opcode for the supplied token. * *

      Parameters:
        `type` - the normalized token index *
      Returns:
        the ASM opcode

    - #### protected int getCompareCode()

      *

      Returns:
        the ASM compare opcode used by this primitive type

    - #### protected ClassNode getDevisionOpResultType()

      *

      Returns:
        the result type for division operations

    - #### protected ClassNode getNormalOpResultType()

      *

      Returns:
        the result type for normal arithmetic operations

    - #### protected int getShiftOperationBytecode(int type)

      * Returns the shift opcode for the supplied token. * *

      Parameters:
        `type` - the normalized token index *
      Returns:
        the ASM opcode

    - #### protected int getStandardOperationBytecode(int type)

      * Returns the arithmetic opcode for the supplied token. * *

      Parameters:
        `type` - the normalized token index *
      Returns:
        the ASM opcode

    - #### protected void removeTwoOperands(org.objectweb.asm.MethodVisitor mv)

      * Removes the two operands already on the operand stack. * *

      Parameters:
        `mv` - the current method visitor

    - #### protected boolean writeBitwiseOp(int type, boolean simulate)

      * writes some the bitwise operations. type is one of BITWISE_OR, * BITWISE_AND, BITWISE_XOR *

      Parameters:
        `type` - the token type *
      Returns:
        true if a successful bitwise operation write

    - #### protected void writeMinusMinus(org.objectweb.asm.MethodVisitor mv)

      * Emits a prefix/postfix decrement. * *

      Parameters:
        `mv` - the current method visitor

    - #### protected void writePlusPlus(org.objectweb.asm.MethodVisitor mv)

      * Emits a prefix/postfix increment. * *

      Parameters:
        `mv` - the current method visitor

    - #### protected boolean writeShiftOp(int type, boolean simulate)

      * Write shifting operations. * Type is one of LEFT_SHIFT, RIGHT_SHIFT, or RIGHT_SHIFT_UNSIGNED * *

      Parameters:
        `type` - the token type *
      Returns:
        true on a successful shift operation write